#include<bits/stdc++.h>
using namespace std;
int n,m,u[20],v[20],x,y,s,ans;
int fa[20];
bool flag;
int find(int x)
{
	return x==fa[x]?x:fa[x]=find(fa[x]);
}
int main()
{
	freopen("barrack.in","r",stdin);
	freopen("barrack.out","w",stdout);
	scanf("%d%d",&n,&m);
	for(int i=1;i<=m;i++)
		scanf("%d%d",&u[i],&v[i]);
	for(int i=1;i<1<<n;i++)
	{
		for(int j=0;j<1<<m;j++)
		{
			flag=1;
			for(int k=1;k<=n;k++)
				fa[k]=k;
			for(int k=1;k<=m;k++)
			{
				if(j&(1<<k-1))
				{
					x=find(u[k]);y=find(v[k]);
					if(x==y) continue;
					fa[x]=y;
				}
			}
			s=0;
			for(int k=1;k<=n;k++)
			{
				if(i&(1<<k-1))
				{
					if(!s) s=find(k);
					else
					{
						if(s!=find(k))
						{
							flag=0;
							break;
						}
					}
				}
			}
			if(flag) ans++;
		}
	}
	printf("%d",ans);
	return 0;
}